<questionnaire>
    <style>
        .dt-buttons .dt-button.buttons-create {
            display: none;
        }

        .dt-buttons .dt-button.buttons-edit {
            border-top-left-radius: 5px !important;
            border-bottom-left-radius: 5px !important;
        }
    </style>
    <data/>
    <script>
        export default {
            onBeforeMount(props, state) {
                this.scrutiny = props.scrutiny
                this.logoutModal = props.logoutModal
            },
            onMounted(props, states) {
                clearErrorMessage()
                RiotUtil.next("data", {
                    logoutModal: this.logoutModal,
                    scrutiny: this.scrutiny,
                    title: "アンケート一覧",
                    name: 'questionnaire',
                    items: ['端末ID', "利用用途", "星数", 'コメント', "協力可否", "備考", "作成日時", "メールアドレス"],
                    service: new QuestionnaireService(),
                    disabledColumns: [2,3,4,5,6,8],
                    // fixedColumns: {leftColumns: 4},
                    ajax: async function (handler) {
                        const email = UserInfo.getInstance().getEmail()
                        const response = await this.service.search(email)
                        if (response.status != "OK" || !response.data || response.data.length < 1) {
                            return handler([])
                        }

                        const jsons = []
                        response.data.forEach(data => {
                            const json = {
                                assetId: data.assetId,
                                usage: data.usage,
                                star: data.star,
                                comment: data.comment,
                                cooperatePossible: data.cooperatePossible,
                                memo: data.memo,
                                updatedAt: data.updatedAt,
                                email: data.email,
                                rowId: data.rowId ? data.rowId : Math.random()
                            }
                            jsons.push(json)
                        })
                        handler(jsons)
                    },
                    initComplete: function() {
                    },
                    draw: function() {
                    },
                    preSubmit: function (e, json, action, self) {
                        if (action == 'remove') return
                    },
                    addJSON: async function (json) {
                        json.columns.forEach(function (column) {
                            if (column.data == 'star') {
                                column.render = function (data, type, row) {
                                    const star = Number(data)
                                    switch (star) {
                                        case 0:
                                            return ''
                                        case 1:
                                            return '★'
                                        case 2:
                                            return '★★'
                                        case 3:
                                            return '★★★'
                                        case 4:
                                            return '★★★★'
                                        case 5:
                                            return '★★★★★'
                                        default:
                                            return ''
                                    }
                                }
                            }
                            if (column.data == 'cooperatePossible') {
                                column.render = function (data, type, row) {
                                    if (data == '1') {
                                        return '協力する'
                                    }
                                    return '協力しない'
                                }
                            }
                        })
                        return json
                    },
                    open: function (e, json, action, editor) {
                    },
                }, "datatables")
            }
        }

        function clearErrorMessage() {
            $("#error-message").text('').addClass('hide')
        }
        function setErrorMessage(message) {
            $("#error-message").text(message).removeClass('hide')
        }

    </script>
</questionnaire>
